/**
 * @file calculaterect.cpp
 * @date 2010/03/07 新規作成
 * @author
 *
 * 中心位置計算クラス
 */
#include "Define.h"
#include "calculaterect.h"

/**
 * デフォルトコンストラクタ
 */
CalculateRect::CalculateRect(){
}

/**
 * 水平軸位置計算
 * @return QRect
 */
QRect CalculateRect::calculateHorizon(int percent, QRect child, QRect parent){
	int left = (parent.width() - child.width()+ 1) * percent / 100;
	int width = child.width();
	child.setLeft(left);
	child.setWidth(width);
	return child;
}

/**
 * 垂直軸位置計算
 * @return QRect
 */
QRect CalculateRect::calculateVertical(int percent, QRect child, QRect parent){
	int top = (parent.height() - child.height()+ 1) * percent / 100;
	int height = child.height();
	child.setTop(top);
	child.setHeight(height);
	return child;
}
