/**
 * @file Test3.cpp
 * @date 2010/03/07 新規作成
 * @author
 *
 * Test3クラス
 */

#include <assert.h>
#include <cstdlib>
#include <iostream>
#include <fstream>
#include <string>
#include "Define.h"
#include "Test3.h"

/**
 * デフォルトコンストラクタ
 */
Test3::Test3(){
}

/**
 * test関数
 */
ReturnValue Test3::run()
{

	assert( test1() == OK );
	assert( test2() == OK );
	assert( test3() == OK );
	assert( test4() == OK );
	assert( test5() == OK );
	assert( test6() == OK );
	assert( test7() == OK );
	assert( test8() == OK );
	assert( test9() == OK );
	assert( test10() == OK );
	assert( test11() == OK );
	assert( test12() == OK );

	return OK;
}

std::string Test3::readFile(std::string filename){
	std::ifstream inputStream;
	char buffer[256];
	std::string string_buffer;

	inputStream.open(filename.c_str());
	if( !inputStream.is_open() ){
		std::cout << filename << std::endl;
		std::cout << "ファイルをオープンできません" << std::endl;
	}else{
		inputStream.getline(buffer, sizeof(buffer));
		string_buffer = buffer;
		inputStream.close();
	}
	return string_buffer;
}

ReturnValue Test3::test1(){
	switch(m_CheckProduct.check(readFile("test3_1.txt"))){
	case SL_C3200 :
		return OK;
	case SL_C3100 :
	case SL_C3000 :
	case SL_C1000 :
	case SL_C860 :
	case SL_C760 :
	case SL_C750 :
	case SL_C700 :
	case SL_NONE :
	default :
		return NG;
	}
	return NG;
}

ReturnValue Test3::test2(){
	switch(m_CheckProduct.check(readFile("test3_2.txt"))){
	case SL_C3100 :
		return OK;
	case SL_C3200 :
	case SL_C3000 :
	case SL_C1000 :
	case SL_C860 :
	case SL_C760 :
	case SL_C750 :
	case SL_C700 :
	case SL_NONE :
	default :
		return NG;
	}
	return NG;
}

ReturnValue Test3::test3(){
	switch(m_CheckProduct.check(readFile("test3_3.txt"))){
	case SL_C3000 :
		return OK;
	case SL_C3200 :
	case SL_C3100 :
	case SL_C1000 :
	case SL_C860 :
	case SL_C760 :
	case SL_C750 :
	case SL_C700 :
	case SL_NONE :
	default :
		return NG;
	}
	return NG;
}

ReturnValue Test3::test4(){
	switch(m_CheckProduct.check(readFile("test3_4.txt"))){
	case SL_C1000 :
		return OK;
	case SL_C3200 :
	case SL_C3100 :
	case SL_C3000 :
	case SL_C860 :
	case SL_C760 :
	case SL_C750 :
	case SL_C700 :
	case SL_NONE :
	default :
		return NG;
	}
	return NG;
}

ReturnValue Test3::test5(){
	switch(m_CheckProduct.check(readFile("test3_5.txt"))){
	case SL_C860 :
		return OK;
	case SL_C3200 :
	case SL_C3100 :
	case SL_C3000 :
	case SL_C1000 :
	case SL_C760 :
	case SL_C750 :
	case SL_C700 :
	case SL_NONE :
	default :
		return NG;
	}
	return NG;
}

ReturnValue Test3::test6(){
	switch(m_CheckProduct.check(readFile("test3_6.txt"))){
	case SL_C760 :
		return OK;
	case SL_C3200 :
	case SL_C3100 :
	case SL_C3000 :
	case SL_C1000 :
	case SL_C860 :
	case SL_C750 :
	case SL_C700 :
	case SL_NONE :
	default :
		return NG;
	}
	return NG;
}

ReturnValue Test3::test7(){
	switch(m_CheckProduct.check(readFile("test3_7.txt"))){
	case SL_C750 :
		return OK;
	case SL_C3200 :
	case SL_C3100 :
	case SL_C3000 :
	case SL_C1000 :
	case SL_C860 :
	case SL_C760 :
	case SL_C700 :
	case SL_NONE :
	default :
		return NG;
	}
	return NG;
}

ReturnValue Test3::test8(){
	switch(m_CheckProduct.check(readFile("test3_8.txt"))){
	case SL_C700 :
		return OK;
	case SL_C3200 :
	case SL_C3100 :
	case SL_C3000 :
	case SL_C1000 :
	case SL_C860 :
	case SL_C760 :
	case SL_C750 :
	case SL_NONE :
	default :
		return NG;
	}
	return NG;
}

ReturnValue Test3::test9(){
	std::string command_string;
	m_MkimageString.setFilename("test3_1.txt");
	m_MkimageString.factory(command_string);
	if( command_string.compare("./mkimage -A arm -O linux -T kernel -C none -a 0xa0008000"
		" -e 0xa0008000 -n \"Linux2.4\" -d zImage uImage") == 0 ){
		return OK;
	}else{
		return NG;
	}
}

ReturnValue Test3::test10(){
	std::string command_string;
	m_MkimageString.setFilename("test3_5.txt");
	m_MkimageString.factory(command_string);
	if( command_string.compare("./mkimage -A arm -O linux -T kernel -C none -a 0xa0008000"
		" -e 0xa0008000 -n \"Linux2.4\" -d zImage uImage") == 0 ){
		return OK;
	}else{
		return NG;
	}
}

ReturnValue Test3::test11(){
	std::string command_string;
	m_NandlogicalString.setFilename("test3_1.txt");
	m_NandlogicalString.factory(command_string);
	if( command_string.compare("./nandlogical /dev/mtd1 READ 0xe0000 0x13BFF0 zImage") == 0 ){
		return OK;
	}else{
		return NG;
	}
}

ReturnValue Test3::test12(){
	std::string command_string;
	m_NandlogicalString.setFilename("test3_5.txt");
	m_NandlogicalString.factory(command_string);
	if( command_string.compare("./nandlogical /dev/mtd1 READ 0xe0000 0x13c000 zImage") == 0 ){
		return OK;
	}else{
		return NG;
	}
}

